Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Asynch_Read_Dgram Class Reference

This class is a factory for starting off asynchronous reads on a UDP socket. This class forwards all methods to its implementation class. More...

`#include <Asynch_IO.h>`

Inheritance diagram for ACE_Asynch_Read_Dgram:

[legend]
Collaboration diagram for ACE_Asynch_Read_Dgram:

[legend]
List of all members.

## Public Methods
| ACE_Asynch_Read_Dgram (void)
| A do nothing constructor. More...
virtual | ~ACE_Asynch_Read_Dgram (void)
| Destructor. More...
int | open (ACE_Handler &handler, ACE_HANDLE handle=ACE_INVALID_HANDLE, const void *completion_key=0, ACE_Proactor *proactor=0)
| Initializes the factory with information which will be used with each asynchronous call. More...
ssize_t | recv (ACE_Message_Block *message_block, size_t &number_of_bytes_recvd, int flags, int protocol_family=PF_INET, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
| This starts off an asynchronous read. More...
ACE_Asynch_Read_Dgram_Impl * | implementation (void) const
| Return the underlying implementation class. More...
## Protected Methods
void | implementation (ACE_Asynch_Read_Dgram_Impl *implementation)
| Set the implementation class. More...
## Protected Attributes
ACE_Asynch_Read_Dgram_Impl * | implementation_
| Implementation class that all methods will be forwarded to. More...

## Detailed Description

This class is a factory for starting off asynchronous reads on a UDP socket. This class forwards all methods to its implementation class.

Once <open> is called, multiple asynchronous <read>s can be started using this class. An ACE_Asynch_Read_Dgram::Result will be passed back to the <handler> when the asynchronous reads completes through the <ACE_Handler::handle_read_dgram> callback.

## Constructor & Destructor Documentation

ACE_Asynch_Read_Dgram::ACE_Asynch_Read_Dgram | ( | void |  | ) |

| A do nothing constructor.

ACE_Asynch_Read_Dgram::~ACE_Asynch_Read_Dgram | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void ACE_Asynch_Read_Dgram::implementation | ( | ACE_Asynch_Read_Dgram_Impl * | implementation | ) | `[protected]`

| Set the implementation class.

ACE_Asynch_Read_Dgram_Impl * ACE_Asynch_Read_Dgram::implementation | ( | void |  | ) | const

| Return the underlying implementation class. Reimplemented from ACE_Asynch_Operation.

int ACE_Asynch_Read_Dgram::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle = ACE_INVALID_HANDLE,
|  | const void * | completion_key = 0,
|  | ACE_Proactor * | proactor = 0
| ) |

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_Asynch_Operation.

ssize_t ACE_Asynch_Read_Dgram::recv | ( | ACE_Message_Block * | message_block,
|  | size_t & | number_of_bytes_recvd,
|  | int | flags,
|  | int | protocol_family = PF_INET,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| This starts off an asynchronous read. Upto <message_block->total_size()> will be read and stored in the <message_block>. <message_block>'s <wr_ptr> will be updated to reflect the added bytes if the read operation is successfully completed. Return code of 1 means immediate success and <number_of_bytes_recvd> will contain number of bytes read. The <ACE_Handler::handle_read_dgram> method will still be called. Return code of 0 means the IO will complete proactively. Return code of -1 means there was an error, use errno to get the error code. Scatter/gather is supported on WIN32 by using the <message_block->cont()> method. Up to ACE_IOV_MAX <message_block>'s are supported. Upto <message_block->size()> bytes will be read into each <message block> for a total of <message_block->total_size()> bytes. All <message_block>'s <wr_ptr>'s will be updated to reflect the added bytes for each <message_block> Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. And so forth. On Win32, <priority> is a no-op. <signal_number> is the POSIX4 real-time signal number to be used for the operation. <signal_number> ranges from ACE_SIGRTMIN to ACE_SIGRTMAX. This argument is a no-op on non-POSIX4 systems.

## Member Data Documentation

ACE_Asynch_Read_Dgram_Impl* ACE_Asynch_Read_Dgram::implementation_`[protected]`

| Implementation class that all methods will be forwarded to. Reimplemented from ACE_Asynch_Operation.

The documentation for this class was generated from the following files:

- Asynch_IO.h
- Asynch_IO.cpp